Fix of centos bootstrap and dut_setup.sh
[csit.git] / bootstrap-centos.sh
1 #!/bin/bash
2 # Copyright (c) 2016 Cisco and/or its affiliates.
3 # Licensed under the Apache License, Version 2.0 (the "License");
4 # you may not use this file except in compliance with the License.
5 # You may obtain a copy of the License at:
6 #
7 #     http://www.apache.org/licenses/LICENSE-2.0
8 #
9 # Unless required by applicable law or agreed to in writing, software
10 # distributed under the License is distributed on an "AS IS" BASIS,
11 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12 # See the License for the specific language governing permissions and
13 # limitations under the License.
14
15 set -x
16
17 cat /etc/hostname
18 cat /etc/hosts
19
20 sudo yum install -y python-devel python-virtualenv
21
22 VIRL_SERVERS=("10.30.51.28" "10.30.51.29" "10.30.51.30")
23
24 VIRL_USERNAME=jenkins-in
25 VIRL_PKEY=priv_key
26 VIRL_SERVER_STATUS_FILE="status"
27 VIRL_SERVER_EXPECTED_STATUS="PRODUCTION"
28
29 VIRL_TOPOLOGY=double-ring-nested.centos7
30 VIRL_RELEASE=csit-centos-7.3-1611_2017-02-14_1.3
31
32 SSH_OPTIONS="-i ${VIRL_PKEY} -o StrictHostKeyChecking=no -o UserKnownHostsFile=/dev/null -o BatchMode=yes -o LogLevel=error"
33
34 TEST_GROUPS=("l2bd,dhcp,gre,honeycomb,l2xc,lisp,softwire" "cop,telemetry,ipsec,ipv6,rpf,tap,vrf" "fds,iacl,ipv4,policer,vlan,vxlan")
35 SUITE_PATH="tests.func"
36
37 SCRIPT_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
38
39 # Create tmp dir
40 mkdir ${SCRIPT_DIR}/tmp
41
42 # Use tmp dir to store log files
43 LOG_PATH="${SCRIPT_DIR}/tmp"
44
45 # Use tmp dir for tarballs
46 export TMPDIR="${SCRIPT_DIR}/tmp"
47
48 SHARED_MEMORY_PATH="/dev/shm"
49
50 function ssh_do() {
51     echo
52     echo "### "  ssh $@
53     ssh ${SSH_OPTIONS} $@
54 }
55
56 rm -f ${VIRL_PKEY}
57 cat > ${VIRL_PKEY} <<EOF
58 -----BEGIN RSA PRIVATE KEY-----
59 MIIEpQIBAAKCAQEA+IHXq87GcqMR1C47rzx6Cbip5Ghq8pKrbqKrP5Nf41HcYrT6
60 GOXl9nFWKsMOzIlIn+8y7Il27eZh7csQGApbg8QLiHMtcYEmWNzKZpkqg4nuAPxX
61 VXwlKgnKX902SrET9Gp9TDayiHtCRWVfrlPPPSA0UEXW6BjLN/uHJ+W/Xzrrab+9
62 asBVa05vT2W6n0KJ66zfCaeDM912mQ6SttscAwFoWDmdHlegiVqrlIG2ABxOvxxz
63 L3dM3iSmlmQlzv9bThjo+nI4KFYh6m5wrZmAo5r/4q9CIJc21HVnTqkGOWJIZz6J
64 73lePJVSq5gYqaoGw3swFEA/MDkOx7baWKSoLQIDAQABAoIBAQCNBeolNp+JWJ76
65 gQ4fwLsknyXSV6sxYyhkDW4PEwwcTU06uqce0AAzXVffxne0fMe48x47+zqBgPbb
66 4huM+Pu8B9nfojUMr5TaYtl9Zbgpk3F8H7dT7LKOa6XrxvZTZrADSRc30+Z26zPN
67 e9zTaf42Gvt0/l0Zs1BHwbaOXqO+XuwJ3/F9Sf3PQYWXD3EOWjpHDP/X/1vAs6lV
68 SLkm6J/9KKE1m6I6LTYjIXuYt4SXybW6N2TSy54hhQtYcDUnIU2hR/PHVWKrGA0J
69 kELgrtTNTdbML27O5gFWU4PLUEYTZ9fN11D6qUZKxLcPOiPPHXkiILMRCCnG5DYI
70 ksBAU/YlAoGBAPxZO9VO18TYc8THV1nLKcvT2+1oSs1UcA2wNQMU55t910ZYinRa
71 MRwUhMOf8Mv5wOeiZaRICQB1PnVWtDVmGECgPpK6jUxqAwn8rgJcnoafLGL5YKMY
72 RVafTe6N5LXgCaOcJrk21wxs6v7ninEbUxxc575urOvZMBkymDw91dwbAoGBAPwa
73 YRhKhrzFKZzdK0RadVjnxKvolUllpoqqg3XuvmeAJHAOAnaOgVWq68NAcp5FZJv0
74 2D2Up7TX8pjf9MofP1SJbcraKBpK4NzfNkA0dSdEi+FhVofAJ9umB2o5LW1n7sab
75 UIrjsdzSJK/9Zb9yTTHPyibYzNEgaJV1HsbxfEFXAoGAYO2RmvRm0phll18OQVJV
76 IpKk9kLKAKZ/R/K32hAsikBC8SVPQTPniyaifFWx81diblalff2hX4ipTf7Yx24I
77 wMIMZuW7Im/R7QMef4+94G3Bad7p7JuE/qnAEHJ2OBnu+eYfxaK35XDsrq6XMazS
78 NqHE7hOq3giVfgg+C12hCKMCgYEAtu9dbYcG5owbehxzfRI2/OCRsjz/t1bv1seM
79 xVMND4XI6xb/apBWAZgZpIFrqrWoIBM3ptfsKipZe91ngBPUnL9s0Dolx452RVAj
80 yctHB8uRxWYgqDkjsxtzXf1HnZBBkBS8CUzYj+hdfuddoeKLaY3invXLCiV+PpXS
81 U4KAK9kCgYEAtSv0m5+Fg74BbAiFB6kCh11FYkW94YI6B/E2D/uVTD5dJhyEUFgZ
82 cWsudXjMki8734WSpMBqBp/J8wG3C9ZS6IpQD+U7UXA+roB7Qr+j4TqtWfM+87Rh
83 maOpG56uAyR0w5Z9BhwzA3VakibVk9KwDgZ29WtKFzuATLFnOtCS46E=
84 -----END RSA PRIVATE KEY-----
85 EOF
86 chmod 600 ${VIRL_PKEY}
87
88 #
89 # Pick a random host from the array of VIRL servers for every test set run
90 # and attempt to reach it and verify it's status.
91 #
92 # The server must be reachable and have a "status" file with
93 # the content "PRODUCTION" to be selected.
94 #
95 # If the server is not reachable or does not have the correct
96 # status remove it from the array and start again.
97 #
98 # Abort if there are no more servers left in the array.
99 #
100 for index in "${!TEST_GROUPS[@]}"; do
101     VIRL_SERVER[${index}]=""
102     while [[ ! "${VIRL_SERVER[${index}]}" ]]; do
103         num_hosts=${#VIRL_SERVERS[@]}
104         if [ $num_hosts == 0 ]
105         then
106             echo "No more VIRL candidate hosts available, failing."
107             exit 127
108         fi
109         element=$[ $RANDOM % $num_hosts ]
110         virl_server_candidate=${VIRL_SERVERS[$element]}
111         virl_server_status=$(ssh ${SSH_OPTIONS} ${VIRL_USERNAME}@${virl_server_candidate} cat $VIRL_SERVER_STATUS_FILE 2>&1)
112         echo VIRL HOST $virl_server_candidate status is \"$virl_server_status\"
113         if [ "$virl_server_status" == "$VIRL_SERVER_EXPECTED_STATUS" ]
114         then
115             # Candidate is in good status. Select this server.
116             VIRL_SERVER[${index}]="$virl_server_candidate"
117         else
118             # Candidate is in bad status. Remove from array.
119             VIRL_SERVERS=("${VIRL_SERVERS[@]:0:$element}" "${VIRL_SERVERS[@]:$[$element+1]}")
120         fi
121     done
122 done
123
124 echo "Selected VIRL servers: ${VIRL_SERVER[@]}"
125
126 # Temporarily download VPP packages from nexus.fd.io
127 DPDK_STABLE_VER=$(cat ${SCRIPT_DIR}/DPDK_STABLE_VER).x86_64
128 VPP_REPO_URL=$(cat ${SCRIPT_DIR}/VPP_REPO_URL_CENTOS)
129 VPP_CLASSIFIER=""
130 if [ "${#}" -ne "0" ]; then
131     arr=(${@})
132     echo ${arr[0]}
133     # DPDK is not part of the vpp build
134     wget -q "${VPP_REPO_URL}/vpp-dpdk-devel/${DPDK_STABLE_VER}/vpp-dpdk-devel-${DPDK_STABLE_VER}${VPP_CLASSIFIER}.rpm" || exit
135 else
136     rm -f *.rpm
137     VPP_STABLE_VER=$(cat ${SCRIPT_DIR}/VPP_STABLE_VER_CENTOS)
138     wget -q "${VPP_REPO_URL}/vpp/${VPP_STABLE_VER}/vpp-${VPP_STABLE_VER}${VPP_CLASSIFIER}.rpm" || exit
139     wget -q "${VPP_REPO_URL}/vpp-debuginfo/${VPP_STABLE_VER}/vpp-debuginfo-${VPP_STABLE_VER}${VPP_CLASSIFIER}.rpm" || exit
140     wget -q "${VPP_REPO_URL}/vpp-devel/${VPP_STABLE_VER}/vpp-devel-${VPP_STABLE_VER}${VPP_CLASSIFIER}.rpm" || exit
141     wget -q "${VPP_REPO_URL}/vpp-dpdk-devel/${DPDK_STABLE_VER}/vpp-dpdk-devel-${DPDK_STABLE_VER}${VPP_CLASSIFIER}.rpm" || exit
142     wget -q "${VPP_REPO_URL}/vpp-lib/${VPP_STABLE_VER}/vpp-lib-${VPP_STABLE_VER}${VPP_CLASSIFIER}.rpm" || exit
143     wget -q "${VPP_REPO_URL}/vpp-plugins/${VPP_STABLE_VER}/vpp-plugins-${VPP_STABLE_VER}${VPP_CLASSIFIER}.rpm" || exit
144 fi
145
146 VPP_RPMS=(*.rpm)
147 echo ${VPP_RPMS[@]}
148 VIRL_DIR_LOC="/tmp"
149 VPP_RPMS_FULL=(${VPP_RPMS[@]})
150
151 # Prepend directory location at remote host to rpm list
152 for index in "${!VPP_RPMS_FULL[@]}"; do
153     VPP_RPMS_FULL[${index}]=${VIRL_DIR_LOC}/${VPP_RPMS_FULL[${index}]}
154 done
155
156 echo "Updated file names: " ${VPP_RPMS_FULL[@]}
157
158 cat ${VIRL_PKEY}
159
160 # Copy the files to VIRL hosts
161 DONE=""
162 for index in "${!VIRL_SERVER[@]}"; do
163     # Do not copy files in case they have already been copied to the VIRL host
164     [[ "${DONE[@]}" =~ "${VIRL_SERVER[${index}]}" ]] && copy=0 || copy=1
165
166     if [ "${copy}" -eq "0" ]; then
167         echo "VPP rpms have already been copied to the VIRL host ${VIRL_SERVER[${index}]}"
168     else
169         scp ${SSH_OPTIONS} *.rpm \
170         ${VIRL_USERNAME}@${VIRL_SERVER[${index}]}:${VIRL_DIR_LOC}/
171
172         result=$?
173         if [ "${result}" -ne "0" ]; then
174             echo "Failed to copy VPP rpms to VIRL host ${VIRL_SERVER[${index}]}"
175             echo ${result}
176             exit ${result}
177         else
178             echo "VPP rpms successfully copied to the VIRL host ${VIRL_SERVER[${index}]}"
179         fi
180         DONE+=(${VIRL_SERVER[${index}]})
181     fi
182 done
183
184 # Start a simulation on VIRL server
185
186 function stop_virl_simulation {
187     for index in "${!VIRL_SERVER[@]}"; do
188         ssh ${SSH_OPTIONS} ${VIRL_USERNAME}@${VIRL_SERVER[${index}]}\
189             "stop-testcase ${VIRL_SID[${index}]}"
190     done
191 }
192
193 # Upon script exit, cleanup the simulation execution
194 trap stop_virl_simulation EXIT
195
196 for index in "${!VIRL_SERVER[@]}"; do
197     echo "Starting simulation nr. ${index} on VIRL server ${VIRL_SERVER[${index}]}"
198     VIRL_SID[${index}]=$(ssh ${SSH_OPTIONS} \
199         ${VIRL_USERNAME}@${VIRL_SERVER[${index}]} \
200         "start-testcase -c ${VIRL_TOPOLOGY} -r ${VIRL_RELEASE} ${VPP_RPMS_FULL[@]}")
201     retval=$?
202     if [ ${retval} -ne "0" ]; then
203         echo "VIRL simulation start failed on ${VIRL_SERVER[${index}]}"
204         exit ${retval}
205     fi
206     if [[ ! "${VIRL_SID[${index}]}" =~ session-[a-zA-Z0-9_]{6} ]]; then
207         echo "No VIRL session ID reported."
208         exit 127
209     fi
210     echo "VIRL simulation started on ${VIRL_SERVER[${index}]}"
211
212     ssh_do ${VIRL_USERNAME}@${VIRL_SERVER[${index}]}\
213      cat /scratch/${VIRL_SID[${index}]}/topology.yaml
214
215     # Download the topology file from VIRL session and rename it
216     scp ${SSH_OPTIONS} \
217         ${VIRL_USERNAME}@${VIRL_SERVER[${index}]}:/scratch/${VIRL_SID[${index}]}/topology.yaml \
218         topologies/enabled/topology${index}.yaml
219
220     retval=$?
221     if [ ${retval} -ne "0" ]; then
222         echo "Failed to copy topology file from VIRL simulation nr. ${index} on VIRL server ${VIRL_SERVER[${index}]}"
223         exit ${retval}
224     fi
225 done
226
227 echo ${VIRL_SID[@]}
228
229 virtualenv --system-site-packages env
230 . env/bin/activate
231
232 echo pip install
233 pip install -r ${SCRIPT_DIR}/requirements.txt
234
235 for index in "${!VIRL_SERVER[@]}"; do
236     pykwalify -s ${SCRIPT_DIR}/resources/topology_schemas/3_node_topology.sch.yaml \
237               -s ${SCRIPT_DIR}/resources/topology_schemas/topology.sch.yaml \
238               -d ${SCRIPT_DIR}/topologies/enabled/topology${index}.yaml \
239               -vvv
240     if [ "$?" -ne "0" ]; then
241         echo "Topology${index} schema validation failed."
242         echo "However, the tests will start."
243     fi
244 done
245
246 function run_test_set() {
247     set +x
248     OLDIFS=$IFS
249     IFS=","
250     nr=$(echo $1)
251     rm -f ${LOG_PATH}/test_run${nr}.log
252     exec &> >(while read line; do echo "$(date +'%H:%M:%S') $line" \
253      >> ${LOG_PATH}/test_run${nr}.log; done;)
254     suite_str=""
255     for suite in ${TEST_GROUPS[${nr}]}; do
256         suite_str="${suite_str} --suite ${SUITE_PATH}.${suite}"
257     done
258     IFS=$OLDIFS
259
260     echo "PYTHONPATH=`pwd` pybot -L TRACE -W 136\
261         -v TOPOLOGY_PATH:${SCRIPT_DIR}/topologies/enabled/topology${nr}.yaml \
262         ${suite_str} \
263         --include vm_envAND3_node_single_link_topo \
264         --include vm_envAND3_node_double_link_topo \
265         --exclude PERFTEST \
266         --exclude SKIP_PATCH \
267         --noncritical EXPECTED_FAILING \
268         --output ${LOG_PATH}/log_test_set_run${nr} \
269         tests/"
270
271     PYTHONPATH=`pwd` pybot -L TRACE -W 136\
272         -v TOPOLOGY_PATH:${SCRIPT_DIR}/topologies/enabled/topology${nr}.yaml \
273         ${suite_str} \
274         --include vm_envAND3_node_single_link_topo \
275         --include vm_envAND3_node_double_link_topo \
276         --exclude PERFTEST \
277         --exclude SKIP_PATCH \
278         --noncritical EXPECTED_FAILING \
279         --output ${LOG_PATH}/log_test_set_run${nr} \
280         tests/
281
282     local_run_rc=$?
283     echo ${local_run_rc} > ${SHARED_MEMORY_PATH}/rc_test_run${nr}
284     set -x
285 }
286
287 set +x
288 # Send to background an instance of the run_test_set() function for each number,
289 # record the pid.
290 for index in "${!VIRL_SERVER[@]}"; do
291     run_test_set ${index} &
292     pid=$!
293     echo "Sent to background: Test_set${index} (pid=$pid)"
294     pids[$pid]=$index
295 done
296
297 echo
298 echo -n "Waiting..."
299
300 # Watch the stable of background processes.
301 # If a pid goes away, remove it from the array.
302 while [ -n "${pids[*]}" ]; do
303     for i in $(seq 0 9); do
304         sleep 1
305         echo -n "."
306     done
307     for pid in "${!pids[@]}"; do
308         if ! ps "$pid" >/dev/null; then
309             echo -e "\n"
310             echo "Test_set${pids[$pid]} with PID $pid finished."
311             unset pids[$pid]
312         fi
313     done
314     if [ -z "${!pids[*]}" ]; then
315         break
316     fi
317     echo -n -e "\nStill waiting for test set(s): ${pids[*]} ..."
318 done
319
320 echo
321 echo "All test set runs finished."
322 echo
323
324 set -x
325
326 RC=0
327 for index in "${!VIRL_SERVER[@]}"; do
328     echo "Test_set${index} log:"
329     cat ${LOG_PATH}/test_run${index}.log
330     RC_PARTIAL_RUN=$(cat ${SHARED_MEMORY_PATH}/rc_test_run${index})
331     RC=$((RC+RC_PARTIAL_RUN))
332     rm -f ${SHARED_MEMORY_PATH}/rc_test_run${index}
333     rm -f ${LOG_PATH}/test_run${index}.log
334     echo
335 done
336
337 # Log the final result
338 if [ "${RC}" -eq "0" ]; then
339     set +x
340     echo
341     echo "========================================================================================================================================"
342     echo "Final result of all test loops:                                                                                                 | PASS |"
343     echo "All critical tests have passed."
344     echo "========================================================================================================================================"
345     echo
346     set -x
347 else
348     if [ "${RC}" -eq "1" ]; then
349         HLP_STR="test has"
350     else
351         HLP_STR="tests have"
352     fi
353     set +x
354     echo
355     echo "========================================================================================================================================"
356     echo "Final result of all test loops:                                                                                                 | FAIL |"
357     echo "${RC} critical ${HLP_STR} failed."
358     echo "========================================================================================================================================"
359     echo
360     set -x
361 fi
362
363 echo Post-processing test data...
364
365 partial_logs=""
366 for index in "${!VIRL_SERVER[@]}"; do
367     partial_logs="${partial_logs} ${LOG_PATH}/log_test_set_run${index}.xml"
368 done
369
370 # Rebot output post-processing
371 rebot --noncritical EXPECTED_FAILING \
372       --output output.xml ${partial_logs}
373
374 # Remove unnecessary log files
375 rm -f ${partial_logs}
376
377 echo Post-processing finished.
378
379 if [ ${RC} -eq 0 ]; then
380     RETURN_STATUS=0
381 else
382     RETURN_STATUS=1
383 fi
384
385 exit ${RETURN_STATUS}

©2016 FD.io a Linux Foundation Collaborative Project. All Rights Reserved.
Linux Foundation is a registered trademark of The Linux Foundation. Linux is a registered trademark of Linus Torvalds.
Please see our privacy policy and terms of use.